import numpy as np

import tensorflow as tf
from tensorflow import keras
from tensorflow.keras.layers import Input, Flatten, Dense, Concatenate
from tensorflow.keras.models import Model

from ngsolve import * #if this line is neglected everything works fine  


# Dummy Tensorflow routines :


def createModel(input_length, output_length):
    ## Defining Layers
    # Input Layer
    inputs   = Input(shape=(input_length,),name="Input_Layer")
    dense1   = Dense(100, activation='selu', name="FC_Layer_1")(inputs)
    dense2   = Dense(50,  activation='selu', name="FC_Layer_2")(dense1)
    # Output layer
    outputs  = Dense(output_length, name="Output_Layer")(dense4)
    ## Create the model using keras Model class
    model    = Model(inputs=inputs, outputs=outputs)

    return model

# Dummy Data
input_data   = np.random.rand(100,25)
output_data  = np.random.rand(100, 3)

# Create a model using the defined function
mymodel = createModel(input_data.shape[-1],output_data.shape[-1])
# Printing the model architecture
mymodel.summary()
# Compile the model
mymodel.compile(optimizer='adam', loss='mse', metrics=['mae'])

# Training the model
print("\nTraining the model ")
training_log = mymodel.fit(x=[input_data, feature_data],y=output_data, epochs=5, verbose=1, validation_split=0.2, shuffle=True)

# Evaluating the model on new dummy data
print("\nEvaluating the model")
testing_log = mymodel.evaluate(x=[np.random.rand(20,25), np.random.rand(20,10)], y=np.random.rand(20,3), verbose=2)
print("\nTest Set performance:\nLoss(mse)   = {:5.3f}\nMetric(mae) = {:5.3f}".format(testing_log[0], testing_log[1]))
